diff --git a/gnu/local.mk b/gnu/local.mk
index 42961e60b2..85858c0df6 100644
--- a/gnu/local.mk
+++ b/gnu/local.mk
@@ -1860,7 +1860,6 @@ dist_patch_DATA =						\
   %D%/packages/patches/perl-5.14-no-sys-dirs.patch		\
   %D%/packages/patches/perl-autosplit-default-time.patch	\
   %D%/packages/patches/perl-class-methodmaker-reproducible.patch \
-  %D%/packages/patches/perl-finance-quote-unuse-mozilla-ca.patch \
   %D%/packages/patches/perl-image-exiftool-CVE-2021-22204.patch	\
   %D%/packages/patches/perl-net-amazon-s3-moose-warning.patch	\
   %D%/packages/patches/perl-net-dns-resolver-programmable-fix.patch	\
diff --git a/gnu/packages/patches/perl-finance-quote-unuse-mozilla-ca.patch b/gnu/packages/patches/perl-finance-quote-unuse-mozilla-ca.patch
deleted file mode 100644
index 5f37bb0ba7..0000000000
--- a/gnu/packages/patches/perl-finance-quote-unuse-mozilla-ca.patch
+++ /dev/null
@@ -1,15 +0,0 @@
-Rather than unconditionally using Mozilla's CA certificates, let the user tell
-LWP's UserAgent where to find certificates with the PERL_LWP_SSL_CA_FILE,
-HTTPS_CA_FILE, PERL_LWP_SSL_CA_PATH, or HTTPS_CA_DIR environment variables
-instead.
-
---- Finance-Quote-1.37/lib/Finance/Quote/Tiaacref.pm.orig	2015-02-01 13:24:41.000000000 -0600
-+++ Finance-Quote-1.37/lib/Finance/Quote/Tiaacref.pm	2015-07-07 20:09:47.278885944 -0500
-@@ -30,7 +30,6 @@
- package Finance::Quote::Tiaacref;
- require 5.005;
- require LWP::Protocol::https;
--require Mozilla::CA;
- 
- use strict;
- 
diff --git a/gnu/packages/web.scm b/gnu/packages/web.scm
index 52d7048fde..b45333ce51 100644
--- a/gnu/packages/web.scm
+++ b/gnu/packages/web.scm
@@ -184,6 +184,7 @@ (define-module (gnu packages web)
   #:use-module (gnu packages pcre)
   #:use-module (gnu packages perl)
   #:use-module (gnu packages perl-check)
+  #:use-module (gnu packages perl-compression)
   #:use-module (gnu packages python)
   #:use-module (gnu packages python-build)
   #:use-module (gnu packages python-check)
@@ -3387,34 +3388,55 @@ (define-public perl-file-listing
 (define-public perl-finance-quote
   (package
    (name "perl-finance-quote")
-   (version "1.47")
+   (version "1.59")
    (source
     (origin
       (method url-fetch)
-      (uri (string-append "https://cpan.metacpan.org/authors/id/E/EC/ECOCODE/"
+      (uri (string-append "https://cpan.metacpan.org/authors/id/B/BP/BPSCHUCK/"
                           "Finance-Quote-" version ".tar.gz"))
       (sha256
-       (base32 "0gzbq85738f299jaw4nj3ljnka380j2y6yspmyl71rgfypqjvbr7"))
-      (patches (search-patches
-                "perl-finance-quote-unuse-mozilla-ca.patch"))))
+       (base32 "0a19y5bj2pvdlfi747ihgz5khjlfkhjakv712r0gz0n6miwjiscs"))))
    (build-system perl-build-system)
+   (native-inputs
+     (list perl-test-harness
+           perl-date-manip
+           perl-date-range
+           perl-date-simple
+           perl-datetime
+           perl-datetime-format-iso8601
+           perl-string-util
+           perl-pathtools
+           perl-test-pod
+           perl-test-pod-coverage))
    (propagated-inputs
-    (list perl-cgi
-          perl-datetime
+    (list perl-datetime
+          perl-datetime-format-strptime
           perl-html-parser
           perl-html-tableextract
+          perl-html-tokeparser-simple
           perl-html-tree
+          perl-html-treebuilder-xpath
+          perl-http-cookiejar
           perl-http-cookies
           perl-http-message
+          perl-io-string
           perl-json
           perl-libwww
           perl-lwp-protocol-https
-          perl-uri))
+          perl-mozilla-ca
+          perl-spreadsheet-xlsx
+          perl-readonly
+          perl-string-util
+          perl-text-template
+          perl-try-tiny
+          perl-web-scraper
+          perl-xml-libxml))
    (home-page "https://metacpan.org/release/Finance-Quote")
    (synopsis "Stock and mutual fund quotes")
    (description
-    "Finance::Quote gets stock quotes from various internet sources, including
-Yahoo! Finance, Fidelity Investments, and the Australian Stock Exchange.")
+    "The @code{Finance::Quote} module retries stock quotes from various
+internet sources, including Yahoo! Finance, Fidelity Investments, and the
+Australian Stock Exchange.")
    (license license:gpl2)))
 
 (define-public perl-gssapi